require 'tmpdir'
require 'yaml'

module Crusade
  module APNS
    class Configuration
      attr_accessor :site_name, :push_id, :url_format,
                    :webservice_url, :allowed_domains, :iconset_dir,
                    :certificate, :certificate_password

      def initialize(attributes)
        self.site_name             = attributes[:site_name]
        self.push_id               = attributes[:push_id]
        self.url_format            = attributes[:url_format]
        self.webservice_url        = attributes[:webservice_url]
        self.allowed_domains       = attributes[:allowed_domains]
        self.iconset_dir           = attributes[:iconset_dir]

        self.certificate           = attributes[:certificate] || 'config/push_certificate.p12'
        self.certificate_password  = attributes[:certificate_password] || nil
      end

      def iconset_files
        %w(16x16 16x16@2x 32x32 32x32@2x 128x128 128x128@2x).map do |size|
          File.join iconset_dir, "icon_#{size}.png"
        end
      end

      def temp_dir
        @temp_dir ||= Dir.mktmpdir
      end
    end
  end
end