require 'delegate'

module Crusade
  module APNS
    class Notification < SimpleDelegator
      attr_reader :device_token

      def initialize(notification, device_token = nil)
        if notification.is_a? Hash
          device_token = notification[:device_token]
          notification = Crusade::Notification.new notification
        end
        super notification
        self.notification = notification
        self.device_token = device_token
      end

      def to_json
        payload.to_json
      end

      def json_size
        to_json.size
      end

      private

      attr_accessor :notification
      attr_writer   :device_token

      def payload
        {
          "aps" => aps
        }
      end

      def alert
        h = {
          "title" => title,
          "body" => body
        }
        h.update "action" => action if action
        h
      end

      def aps
        h = {
          "alert" => alert,
        }
        h.update "url-args" => url_args if url_args.any?
        h
      end
    end
  end
end