module Crusade
  module APNS
    class NotificationEncoder
      def initialize configuration
        self.configuration = configuration
      end

      def encode notification
        to_binary(notification)
      end

      private

      attr_accessor :configuration

      def to_binary(notification)
        [
           1,
           id_for_pack,
           expiry,
           0,
           32,
           notification.device_token,
           notification.json_size,
           notification.to_json
        ].pack("cNNccH*na*")
      end

      def expiry
        86400
      end

      def id_for_pack
        0
      end
    end
  end
end