require 'tmpdir'
require 'fileutils'
require 'digest'

module Crusade
  module APNS
    class DirectoryStructureGenerator
      def initialize configuration
        self.configuration = configuration
      end

      def generate
        copy_icons

        configuration.temp_dir
      end

      def clean
        FileUtils.remove_entry_secure configuration.temp_dir
      end

      private

      attr_accessor :configuration

      def copy_icons
        icon_dir = File.join configuration.temp_dir, 'icon.iconset'

        FileUtils.mkdir icon_dir
        %w(16x16 16x16@2x 32x32 32x32@2x 128x128 128x128@2x).each  do |size|
          FileUtils.copy File.join(configuration.iconset_dir, "icon_#{size}.png"), 
                         icon_dir
        end
        
      end
    end
  end
end