require 'json'

require 'crusade/apns/crypto/user_token_generator'

module Crusade
  module APNS
    class WebsiteFileGenerator
      def initialize user_id, configuration
        self.configuration = configuration
        self.user_id       = user_id
      end

      def generate
        to_hash.to_json
      end

      private

      attr_accessor :configuration, :user_id

      def to_hash
        {
          "websiteName"         => configuration.site_name,
          "websitePushID"       => configuration.push_id,
          "allowedDomains"      => configuration.allowed_domains,
          "urlFormatString"     => configuration.url_format,
          "authenticationToken" => user_token_generator.generate,
          "webServiceURL"       => configuration.webservice_url
        }
      end

      def user_token_generator
        Crusade::APNS::UserTokenGenerator.new(user_id)
      end
    end
  end
end