require 'zip'
require 'fileutils'

module Crusade
  module APNS
    class ZipFileGenerator
      def initialize configuration, directory, destination
        self.configuration = configuration
        self.directory = directory
        self.destination = destination
      end

      def generate
        Zip::File.open(destination, Zip::File::CREATE) do |zipfile|
          Dir.glob("#{directory}/**/*").each do |file|
            title = Pathname.new(file).relative_path_from(Pathname.new(directory))
            zipfile.add(title, file)
          end
        end
      end

      def clean
        FileUtils.remove_entry_secure destination
      end

      private

      attr_accessor :configuration, :directory, :destination
    end
  end
end