module Crusade
  module APNS
    class SocketConnection
      attr_accessor :host, :port

      def initialize(configuration)
        self.configuration = configuration

        self.host = 'gateway.push.apple.com'
        self.port = 2195
      end

      def send data
        write data
      end

      private

      attr_accessor :configuration

      def open_connection
        sock         = TCPSocket.new(host, port)
        ssl          = OpenSSL::SSL::SSLSocket.new(sock, context)
        ssl.connect

        return sock, ssl
      end

      def write binary
        sock, ssl = open_connection

        ssl.write(binary)

        ssl.close
        sock.close
      end

      def context
        ssl_context      = OpenSSL::SSL::SSLContext.new
        ssl_context.cert = OpenSSL::X509::Certificate.new(p12_certificate.certificate.to_pem)
        ssl_context.key  = OpenSSL::PKey::RSA.new(p12_certificate.key.to_pem)

        ssl_context.verify_mode = OpenSSL::SSL::VERIFY_NONE

        ssl_context
      end

      def p12_certificate
        @p12 ||= OpenSSL::PKCS12.new File.read(configuration.certificate),
                                     configuration.certificate_password
      end
    end
  end
end